#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>
PSP_MODULE_INFO("TriSqu", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144];
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)

// 描画用Vertex構造体
typedef struct Vertex{
	float x, y, z;
}Vertex;
Vertex __attribute__((aligned(16))) tri[3]; // トライアングル
Vertex __attribute__((aligned(16))) squ[2]; // スクエア

// メインルーチン
int main() {
	pspDebugScreenInit();
	// gu設定一覧
	sceGuInit(); sceGuStart(GU_DIRECT, list); sceGuDrawBuffer(GU_PSM_8888, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x88000, BUF_WIDTH);
	sceGuDepthBuffer((void*)0x110000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT); sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST); sceGuFinish(); sceGuSync(0,0);
	sceDisplayWaitVblankStart(); sceGuDisplay(GU_TRUE);
	while(1){
		sceGuStart(GU_DIRECT,list); sceGuClearColor(0xFFFFFFFF); // 背景は白
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
		sceGuColor(0xFF000000);	// 描画色を黒色に指定

		// トライアングル用パラメータをセット。上(25,5)-右(45,40)-左(5,40)の3点
		tri[0].x = 25.0f; tri[1].x = 45.0f; tri[2].x = 5.0f;
		tri[0].y =  5.0f; tri[1].y = 40.0f; tri[2].y = 40.0f;
		tri[0].z = 0; tri[1].z = 0; tri[2].z = 0;
		// GU_TRIANGLES、頂点3つ、構造体triを渡す。
		sceGuDrawArray(GU_TRIANGLES, GU_VERTEX_32BITF|GU_TRANSFORM_2D, 3, 0, tri);

		sceGuColor(0xFF0000FF);	// スクエアはABGRのRにFFを与えて赤色に。
		// スクエア用パラメータをセット。左上(50,5)-右下(85,40)範囲のハコを描画
		squ[0].x = 50.0f; squ[1].x = 85.0f;
		squ[0].y =  5.0f; squ[1].y = 40.0f;
		squ[0].z = 0; squ[1].z = 0;
		// GU_TRIANGLES、頂点2つ、構造体squを渡す。
		sceGuDrawArray(GU_SPRITES, GU_VERTEX_32BITF|GU_TRANSFORM_2D, 2, 0, squ);

		// ここまで
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
	}
	return 0;
}
